#include <stdlib.h>

#include "attr.h"
#include "mem.h"
#include "node.h"
#include "symbols.h"

static void disposeNodes()
{
  node n, tmp;

  for(n=nodes; n; n=tmp)
    {
      tmp=n->next;
      disposeNode(n);
    }
}

static void disposeEdges()
{
  edge e, tmp;

  for(e=edges; e; e=tmp)
    {
      tmp=e->next;
      deleteEdge(e);
    }
}

void cleanUp()
{
  disposeAttributes();
  disposeEdges();	/* must be done before deleting nodes */
  disposeNodes();
  disposeSymbols();
  disposeFreeLists();
}
