#include <stdio.h>
#include <string.h>

#include "attr.h"
#include "io.h"
#include "node.h"
#include "output.h"
#include "printPS.h"

extern int onlyDraft;
float FontSize = 5.0;
const char * FontName = "Helvetica";

void printPrologPS(char* title)
{
  if(verboseFlag)
    {
      fprintf(stderr, VERBOSESTR
              "title of postcript file is `%s'\n",title);
      fprintf(stderr, VERBOSESTR
              "using scaling factor of %g\n", scale);
    }

  fprintf(io_output,"%%!PS-Adobe-3.0 EPSF-3.0\n%%%%BoundingBox: 0 0 ");

  if(landscape) fprintf(io_output,"%.2f %.2f\n", ysize, xsize);
  else          fprintf(io_output,"%.2f %.2f\n", xsize, ysize);

  fprintf(io_output,"\
%%%%Pages: 1\n\
%%%%Title: %s\n\
%%%%Creator: lg-0.1\n\
%%%%EndComments\n\
%%%%BeginProlog\n\
%%%%EndProlog\n\
%%%%BeginSetup\n\
%%%%EndSetup\n\
save\n\
\n\
", title);

  if(landscape) fprintf(io_output, "90 rotate 1 -1 scale\n");
  else fprintf(io_output, "0 %.2f translate 1 -1 scale\n", ysize);

  fprintf(io_output,"\
1 setlinecap 0 setlinejoin\n\
\n\
/pt { %.2f mul } bind def\n\
/F %.2f def\n\
/%s findfont F scalefont setfont\n\
\n\
/TickLengthFactor 4 def\n\
/TickHeightFactor 2 def\n\
/TickDelta {\n\
  1 LT 2 div\n\
  TickHeightFactor TickLengthFactor atan sin div\n\
} def\n\
/Tick {\n\
  currentlinejoin\n\
  currentlinecap\n\
  currentdash\n\
  0 setlinejoin\n\
  0 setlinecap\n\
  [] 0 setdash\n\
  newpath\n\
    TickLengthFactor LT TickDelta add neg\n\
    TickHeightFactor LT 2 copy moveto\n\
    TickDelta neg 0 lineto\n\
    neg lineto\n\
  stroke\n\
  setdash\n\
  setlinecap\n\
  setlinejoin\n\
} def\n\
\n\
/CircleSize { 3 pt } bind def\n\
/Circle { %% x y\n\
  newpath\n\
    1 index CircleSize add 1 index moveto\n\
    CircleSize 0 360\n\
    5 copy arc\n\
    1 setgray\n\
  fill\n\
  newpath\n\
    CL setrgbcolor\n\
    arc\n\
  stroke\n\
} bind def\n\
\n\
/Empty { %% x y\n\
  newpath\n\
    1 index CircleSize add 1 index moveto\n\
    CircleSize 0 360\n\
    5 copy arc\n\
    1 setgray\n\
  fill\n\
} bind def\n\
\n\
/DotSize { 0.75 pt } bind def\n\
/Dot { %% x y\n\
  newpath\n\
    CL setrgbcolor\n\
    1 index DotSize add 1 index moveto\n\
    DotSize 0 360 arc\n\
  fill\n\
} bind def\n\
\n\
/LinePreprocessing {\n\
  /ydelta exch 3 index sub def\n\
  /xdelta exch 3 index sub def\n\
  /savematrix matrix currentmatrix def\n\
  translate ydelta xdelta atan rotate\n\
  xdelta dup mul ydelta dup mul add sqrt\n\
} bind def\n\
\n\
/Line {\n\
  newpath\n\
    moveto\n\
    lineto\n\
  stroke\n\
} bind def\n\
\n\
/LineWithTickToCircle {\n\
  LinePreprocessing\n\
  CircleSize sub 1 LT 2 div sub\n\
  dup TickDelta 2 mul sub 0 0 0 newpath moveto lineto stroke\n\
  0 translate Tick\n\
  savematrix setmatrix\n\
} bind def\n\
\n\
/LineWithTickFromCircle {\n\
  LinePreprocessing\n\
  0 CircleSize 1 LT 2 div add\n\
  TickDelta 2 mul add\n\
  0 newpath moveto lineto stroke\n\
  CircleSize 1 LT 2 div add\n\
  0 translate 180 rotate Tick\n\
  savematrix setmatrix\n\
} bind def\n\
\n\
/Diamond { %% x y \n\
  /savematrix matrix currentmatrix def\n\
  translate 45 rotate\n\
  0 0 Box\n\
  savematrix setmatrix\n\
} bind def\n\
\n\
/BoxSize { 2.8 pt } bind def\n\
/Box { %% x y \n\
  newpath\n\
    1 index BoxSize add\n\
    1 index BoxSize add moveto\n\
    0 BoxSize 2 mul neg rlineto\n\
    BoxSize 2 mul neg 0 rlineto\n\
    0 BoxSize 2 mul rlineto\n\
  closepath\n\
  1 setgray fill\n\
  newpath\n\
    1 index BoxSize add\n\
    1 index BoxSize add moveto\n\
    0 BoxSize 2 mul neg rlineto\n\
    BoxSize 2 mul neg 0 rlineto\n\
    0 BoxSize 2 mul rlineto\n\
  closepath\n\
  CL setrgbcolor stroke\n\
  pop pop\n\
} bind def\n\
\n\
/Invisible { pop pop } bind def\n\
\n\
/" PCCNAME " { %% post components code\n\
  1 LT setlinewidth\n\
  CL setrgbcolor\n\
  LS setdash\n\
} def\n\
\n\
/BD { bind def } bind def\n\
\n\
/S {\n\
  /savematrix matrix currentmatrix def\n\
  translate\n\
  1 -1 scale\n\
  dup stringwidth pop 2 div neg F 0.35 mul neg moveto show\n\
  savematrix setmatrix\n\
} bind def\n\
", scale, FontSize * scale, FontName);

  prS("/" LINENAME " { Line } bind def\n");
  prS("/" NODENAME " { Circle } bind def\n"); /* should not be necessary */
}

void printTrailerPS()
{
  fprintf(io_output,"\
\n\
restore\n\
showpage\n\
%%%%Trailer\n\
%%%%EOF\n\
");
}

extern char* documentTitle;

static char transId[] = {
 '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
};

static char* AsciiId(node n)
{
  static char buffer[10]; /* should be big enough */

  unsigned int i = n->aux.id;
  char *p = buffer+9;
  *p = '\0';

  if(i)
    {
      while(i)
        {
#ifdef DEBUG
          if(p<=buffer) error("internal in AsciiId: buffer overflow");
#endif
	  *--p= transId[ i % sizeof(transId) ];
	  i /= sizeof(transId);
	}
    }
  else
    *--p = '0';

#ifdef DEBUG
          if(p<=buffer) error("internal in AsciiId: buffer overflow");
#endif

  *--p = 'N';

  return p;
}

static void printPSString(const char * s, FILE * file)
{
  while(*s)
    {
      if(*s=='(' || *s==')') fputc('\\', file);
      fputc(*s++, file);
    }
}

static void printAlternative()
{
  int id;
  edge e; node n;
  char* lastAttr;

  if(onlyDraft) useDraftAttr();

  ensureOutputFileIsOpen();
  printPrologPS(documentTitle);

  printPSCodeOfUsedComps();
  printPSAttributeDefs();

  for( n=nodes, id=0; n; n=cdr(n), id++)
    {
       n->aux.id = id;
       fputc('/', io_output);
       fputs(AsciiId(n), io_output);
       fprintf(io_output, "{%.2f %.2f}BD\n",
               xUnits2points(n->xpos), yUnits2points(n->ypos) );
    }

  for( lastAttr = 0, e = edges; e; e = cdr(e))
    {
      if(lastAttr != e->attr->shortname)
        {
	  fputc('\t', io_output);
	  fputs(e->attr->shortname, io_output);
	}
      fputc('\n', io_output);
      lastAttr = e->attr->shortname;
      fputs(AsciiId(e->from), io_output); fputc('\t', io_output);
      fputs(AsciiId(e->to), io_output); fputc('\t', io_output);
      fputs(LINENAME, io_output);
    }
  
  for( n=nodes; n; n = cdr(n))
    {
      if(lastAttr != n->attr->shortname)
        {
	  fputc('\t', io_output);
	  fputs(n->attr->shortname, io_output);
	}
      fputc('\n', io_output);
      lastAttr = n->attr->shortname;
      fputs(AsciiId(n), io_output);
      fputs("\t" NODENAME, io_output);
    }

  fprintf(io_output,"\n");

  if(!onlyDraft)
    {
      for(n=nodes; n; n=cdr(n))
        {
	  label l = n->label;
	  if(l)
	    {
	      const char * s = l->text;
	      if(s)
	        {
		  fputc('(', io_output);
		  printPSString(s, io_output);
		  fputs(")\t", io_output);
                  fputs(AsciiId(n), io_output);
		  fputs("\tS\n", io_output);
		}
	    }
	}
    }
  
  printTrailerPS();
}

void printKoos()
{
  int id;
  node n;
  edge e;

  ensureOutputFileIsOpen();

  for(n=nodes, id=1; n; n=cdr(n))
    {
      fprintf(io_output, "node ");

      if(strcmp(n->name, DUMMY_NODE_NAME)==0)
        {
	  fprintf(io_output, "@%d", id);
	  n->aux.id = id++;
	}
      else
        {
	  fprintf(io_output, "%s", n->name);
	  n->aux.id = 0;
	}

      fprintf(io_output, " %.2f %.2f %s %s\n",
        xUnits2points(n->xpos), yUnits2points(n->ypos),
        n->attr->name,
        n->label ? n->label->text : "");
    }

  for(e=edges; e; e=e->next)
    {
      node f = e->from, t = e->to;
      fprintf(io_output, "edge ");

      if(f->aux.id) fprintf(io_output, "@%d ", f->aux.id);
      else fprintf(io_output, "%s ", f->name);

      if(t->aux.id) fprintf(io_output, "@%d ", t->aux.id);
      else fprintf(io_output, "%s ", t->name);
        
      fprintf(io_output, "%s\n", e->attr->name);
    }
}

void (*printAll)() = &printAlternative;

void printAllOld()
{
  edge e; node n;
  char* lastAttr;

  if(onlyDraft) useDraftAttr();

  ensureOutputFileIsOpen();
  printPrologPS(documentTitle);

  printPSCodeOfUsedComps();
  printPSAttributeDefs();

  for( lastAttr = 0, e = edges; e; e = cdr(e))
    {
      if(lastAttr != e->attr->shortname)
        fprintf(io_output,"\t%s", e->attr->shortname);
      fprintf(io_output,"\n");
      lastAttr = e->attr->shortname;
      fprintf(io_output,"%.3f\t%.3f\t%.3f\t%.3f\t" LINENAME,
             xUnits2points(e->from->xpos), yUnits2points(e->from->level) ,
             xUnits2points(e->to->xpos), yUnits2points(e->to->level));
    }
  
  for( n=nodes; n; n = cdr(n))
    {
      if(lastAttr != n->attr->shortname)
        fprintf(io_output,"\t%s", n->attr->shortname);
      fprintf(io_output,"\n");
      lastAttr = n->attr->shortname;
      fprintf(io_output,"%.3f\t%.3f\t" NODENAME,
             xUnits2points(n->xpos), yUnits2points(n->level) );
    }

  fprintf(io_output,"\n");
  
  printTrailerPS();
}
