%{
#include <ctype.h>

#include "io.h"
#include "symbols.h"
#include "y.tab.h"

#include "macros.h"

#undef abs

static char* lower_yytext()
{
  char *s;
  for(s=yytext; *s; *s++=tolower(*s))
    ;
  return yytext;
}

static char* stripString()
{
  yytext[strlen(yytext)-1] = '\0';
  return yytext+1;
}

%}

%%
"%".*\n			;
'[a-zA-Z0-9]*		{
			  yylval.str = yytext+1;
			  return(STRING);
			}
\"[^\"]*\"		{
			  yylval.str = stripString();
			  return(STRING);
			}
[ \n\t]+		;
"@"[0-9]+		{
			  yylval.num=atoi(yytext+1);
			  if(yylval.num>=MAXINT) yyerror("*** level exceeded maximum level");
			  return(LEVEL);
			}
[a-zA-Z0-9_\-]+		{ yylval.symb=findSymbol(lower_yytext()); return(IDENT); }
"<"			return(LESSTHAN);
">"			return(GREATERTHAN);
"{"			return(LC);
"}"			return(RC);
","			return(KOMMA);
":"			return(COLON);
<<EOF>>			yyterminate();

.			yyerror("unknown char");
%%
